﻿# -*- coding: utf-8 -*-
import xbmcplugin, xbmcgui
import urllib, urlparse
import re
from xml.dom.minidom import parseString
import cntv

def httpget(url):
	try:
		file = urllib.urlopen(url)
		content = file.read()
		file.close()
		return content
	except:
		print url
		print 'captured'
		return False

def item(title, url, isFolder = True):
	listitem = xbmcgui.ListItem(title)
	xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urllib.urlencode({'url': url}), listitem, isFolder)

def play(title, urls):
	listitem = xbmcgui.ListItem(title)
	i = 0
	for suburl in urls:
		if i == 0:
			url = suburl
		elif i == 1:
			url = 'stack://' + url + ' , ' + suburl
		else:
			url = url + ' , ' + suburl
		i = i + 1
	if i == 0:
		return
	xbmc.Player().play(url, listitem)

handle = int(sys.argv[1])
if sys.argv[2] == '':
	url = 'http://ims.tian-le.com/cntv.php'
	content = httpget(url)
	if content == False:
		xbmcgui.Dialog().ok('错误', '错误000')
		sys.exit(0)
	try:
		dom = parseString(content)
	except:
		xbmcgui.Dialog().ok('错误', '错误001')
		sys.exit(0)
	for element in dom.getElementsByTagName('item'):
		title = element.getElementsByTagName('title')[0].firstChild.nodeValue
		url = element.getElementsByTagName('url')[0].firstChild.nodeValue
		item(title, url, False)
	xbmcplugin.endOfDirectory(handle)
else:
	url = urlparse.parse_qs(urlparse.urlparse(sys.argv[2]).query)['url'][0]
	if re.match(r'http://vdn\.live\.cntv\.cn/api2/live\.do.*', url):
		ret = cntv.live(url)
		if ret[0] == False:
			xbmcgui.Dialog().ok('错误', '错误代码: ' + ret[1])
		else:
			listitem = xbmcgui.ListItem('')
			xbmc.Player().play(ret[1], listitem)
	else:
		ret = cntv.play(url)
		if ret[0] == False:
			xbmcgui.Dialog().ok('错误', '错误代码: ' + ret[1])
		else:
			play(ret[0], ret[1])
