﻿# -*- coding: utf-8 -*-
import urllib
import urlparse
import urllib2, cookielib
import re, json

def httpget(url):
	file = urllib2.urlopen(url)
	content = file.read()
	file.close()
	return content

def live(url):
	try:
		content = httpget(url)
	except:
		return [False, 'cntv live2 100']
	try:
		data = json.loads(content)
	except:
		return [False, 'cntv live2 101']
	if data.has_key('hls_url') == False:
		return [False, 'cntv live2 102']
	for item in data['hls_url']:
		url = data['hls_url'][item]
		url = url.replace('vtime.cntv.cloudcdn.net:8000', 'vtime.cntv.cloudcdn.net') #Global (HDS/FLV) - wrong port
		url = url.replace('tv.fw.live.cntv.cn', 'tvhd.fw.live.cntv.cn') #China - 403 Forbidden
		try:
			content = httpget(url)
			break
		except:
			continue
	print url
	query = urlparse.parse_qs(urlparse.urlparse(url).query)
	if query.has_key('AUTH') == False:
		return [False, 'cntv live2 103']
	auth = query['AUTH'][0]
	url = url + '|' + urllib.urlencode( { 'Cookie' : 'AUTH=' + auth } )
	return [True, url]

def play(url):
	try:
		content = httpget(url)
	except:
		return [False, 'cntv play 100']
	videoCenterId = re.search('"videoCenterId","(.*?)"', content)
	if videoCenterId == None:
		return [False, 'cntv play 101']
	videoCenterId = videoCenterId.group(1)
	url = 'http://vdn.apps.cntv.cn/api/getHttpVideoInfo.do?pid=' + videoCenterId
	try:
		content = httpget(url)
	except:
		return [False, 'cntv play 102']
	try:
		data = json.loads(content)
	except:
		return [False, 'cntv play 103']
	try:
		title = data['title']
		chapters = data['video']['chapters']
	except:
		return [False, 'cntv play 104']
	urls = []
	for chapter in chapters:
		try:
			suburl = chapter['url']
		except:
			return [False, 'cntv play 105']
		urls.append(suburl)
	return [title, urls]
